
#include <stdio.h>

#define MAX 20010

char p[202][202];
char z[202][202];
int q[MAX][26];
int g[MAX];
int r,s;
int lc;

void initl() {
    lc = 1;
    for (int k = 0; k < 26; k++) {
       q[0][k] = 0;
    }    
    g[0] = 0;
}

void addword(char *s) {
    int i = 0;
    int f = 0;
    while (s[i] != 0) {
        char c = s[i++] - 'a';
	if (q[f][c] == 0) {
	    q[f][c] = lc;
	    for (int k = 0; k < 26; k++) {
	       q[lc][k] = 0;
	    }
	    g[lc] = 0;
	    lc++;
	}
	//printf("%d ", f);
	f = q[f][c];	
    }
    //printf("%d\n", f);
    g[f] = 1;
}

void hled() {    
    for (int i = 0; i < r; i++) {
       for (int j = 0; j < s; j++) {
           for (int dx = -1; dx <= 1; dx++) {
	       for (int dy = -1; dy <= 1; dy++) {
	          if (dy != 0 || dx != 0) {
	           //printf("i: %d j: %d dx: %d dy: %d\n", i, j, dx, dy);
	           int f = 0;
		   int x = j; int y = i;
		   int fc = 0;
		   do {
		       //printf("f: %d\n", f);
		       if (g[f]) {
		           //printf("found %d %d %d\n", i, j, fc);
		           int y1 = i; int x1 = j;
			   for (int k = 0; k < fc; k++) {
			       z[y1][x1] = 1;
               		       x1 = (x1 + dx +s) % s;
	            	       y1 = (y1 + dy + r)  % r;			       
			   }
		       }
  		       char c = p[y][x];
		       if (q[f][c] == 0) break;
		       f = q[f][c];
		       x = (x + dx + s) % s;
		       y = (y + dy + r) % r;
		       fc++;
		   } while (1);
	       }
	      }
	   }
       }
    }
}

void res() {     
    scanf("%d %d\n", &r, &s);
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < s; j++) {
	    char c = getchar() - 'a';
	    p[i][j] = c;
  	}
	getchar();
    } 
    int k;
    scanf("%d\n", &k);
    initl();
    for (int i = 0; i < k; i++) {
        char s[30];
	gets(s);
        addword(s);
    }
    for (int i = 0; i < r; i++) {
        for (int j = 0; j < s; j++) {
	   z[i][j] = 0;
	}
    }
    hled();
    for (int i = 0; i < r; i++) {
       for (int j = 0; j < s; j++) {
           if (z[i][j] == 0) {
	      putchar(p[i][j] + 'a');
	   }
       }
    }
    putchar('\n');
}


int main() {
   int n;
   scanf("%d", &n);
   for (int i = 0; i < n; i++) {
      res();
   }
   return 0;
}
